
import java.util.Random;

public class EscapeAnalysis {

    static Random rand = new Random();

    private static class InnerEA {

        int number = rand.nextInt();

        private int getMagicNumber() {
            int ret = number;
            //number = -1;
            return ret;
        }
    }

    static int doLoop() {
        int computation = 0;
        for (int i = 0; i < 1000000000; i++) {
            InnerEA ea = new InnerEA();
            computation += ea.getMagicNumber();
        }
        return computation;
    }

    /**
     * run with -verbose:gc to see GC activity run with -XX:+DoEscapeAnalysis to
     * turn on escape analysis run with -XX:-DoEscapeAnalysis to turn off escape
     * analysis
     */
    public static void main(String[] args) {
        long time = System.currentTimeMillis();
        System.out.println("start");

        int computation = doLoop();

        System.out.println(computation);
        System.out.println("Time approx. " + (System.currentTimeMillis() - time) / 1000 + "s");
    }

}
