
import java.util.ArrayList;
import java.util.List;

public class EscapeAnalysis1 {

    int fragmentIt(int a) {
        return a / 2;
    }

    /**
     * run with -verbose:gc to see GC activity 
     * run with -XX:+DoEscapeAnalysis to turn on escape analysis
     * run with -XX:-DoEscapeAnalysis to turn off escape analysis
     */
    public static void main(String[] args) {
        long time = System.currentTimeMillis();
        System.out.println("start");

        int computation = 0;

        //needed for storing the objects
        //List<EscapeAnalysis> list = new ArrayList<>();
        for (int j = 0; j < 2; j++) {
            for (int i = 0; i < 2000000000; ++i) {
                EscapeAnalysis1 ea = new EscapeAnalysis1();
                computation += ea.fragmentIt(i);
                // store the objects for future use
                //list.add(ea);
            }
        }
        
        System.out.println(computation);
        System.out.println("Time approx. " + (System.currentTimeMillis() - time) / 1000 + "s");
    }

}
